#ifndef _BCSTCPLINK_H_
#define _BCSTCPLINK_H_

#include "Link.h"
#include "LinkUtils.h"
#include <arpa/inet.h>
#include <netdb.h>

#include <math.h>
#include <vector>
#include <string.h>
#include <errno.h>


#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <stdio.h>

#include <unistd.h>
#include <fcntl.h>


#include <string>       // std::string
#include <iostream>     // std::cout
#include <sstream>      // std::stringstream


#include <algorithm>

#include <map>


namespace Link_ns {

#define TCPMSGSIZE 1023
#define BCS_ERROR_REPLY "*** ERROR"
// il bcs non risponde cosi' velocenemte, allora delay in ms
#define BCS_MIN_DELAY 100

class BcsTcpLink : public Link 
{
private:
        int _TCPSocket;

public:
	BcsTcpLink(string target);
	~BcsTcpLink();

	string raw_io(string quest, bool setstate);

        uvalues_t update(string channel);
	bool  refresh() { return true;};

	double abactpos(string channel);

private:
	string rx3(double tmo /*ms*/, __attribute__((unused)) double nexttmo /*ms*/);


}; /* class BcsTcpLink */


} /* namespace Link_ns */
#endif /* _BCSTCPLINK_H_ */
