#ifndef __BRIEFLOG_H__
#define __BRIEFLOG_H__

#include <limits.h>
#include <iostream>
#include <string>
#include <sstream>

#include <sys/time.h>


namespace BriefLog_ns {

inline std::string s_prtlog(std::string _name, std::string obj, std::string s){
  struct tm * timeinfo;
  struct timeval tv;
  gettimeofday(&tv, NULL);

  char buffer [80];
  char buffer2 [80];

  timeinfo = localtime (&tv.tv_sec);
  strftime (buffer,80,"%F %T",timeinfo);
  snprintf(buffer2, 80,".%03d ",(int)((float)tv.tv_usec/1000+0.5));

  std::stringstream r;
  r << buffer;
  r << buffer2;
  r << ":LA: " << _name << " ";
  if ( obj.size() >= 1 ){
      r << obj;
      r << " ";
  }
  r << s;

  return r.str();
}


class BriefLog {

private:
	long int do_log;
	std::string _name;

public:
	BriefLog(std::string name);
	~BriefLog() {};

	void log(std::string obj, std::string msg); 
	void log();
	void nolog();
	

};


} //namespace
#endif /* __BRIEFLOG_H__ */
