#ifndef _GALILTANGOLINK_H_
#define _GALILTANGOLINK_H_

#include "Link.h"
#include "tango.h"

#include <map>

namespace Link_ns {

#define API_CorbaException		"API_CorbaException"
#define API_DeviceTimedOut		"API_DeviceTimedOut"
#define API_CantConnectToDevice		"API_CantConnectToDevice"
#define API_CommandFailed		"API_CommandFailed"


#define TANGO_GROUP_SPARSE_ATTRIBUTES	_LINKFLAG(TANGO_CHAN_TYPE,   1)
#define TANGO_GROUP_ATTRIBUTE      	_LINKFLAG(TANGO_CHAN_TYPE,   2)
#define TANGO_GROUP_ATTRIBUTE_2      	_LINKFLAG(TANGO_CHAN_TYPE,   3)

class GalilTangoLink : public Link 
{
private:
	Tango::DeviceProxy *dev;
        std::map<string,char> AN;


public:
	GalilTangoLink(string target);
	~GalilTangoLink();

	string raw_io(string quest, bool setstate);

        uvalues_t update(string channel);
	bool  refresh();


}; /* class GalilTangoLink */


} /* namespace Link_ns */
#endif /* _GALILTANGOLINK_H_ */
