#include "BriefLog.h"

namespace BriefLog_ns {

BriefLog::BriefLog(std::string name){
	do_log = 0;
	_name = name;
	#ifdef _DBG_BRIEFLOG
		std::stringstream ss;
		ss.str("");
		ss << "do_log=" << do_log;
		std::cout << s_prtlog( _name, "BriefLog::log() CREATE", ss.str()) << std::endl;
	#endif
}

void BriefLog::nolog(){
	do_log = -1;
}

void BriefLog::log(){
	#ifdef _DBG_BRIEFLOG
		std::cout << s_prtlog( _name, "BriefLog::log()", "close") << std::endl;
	#endif
	if (do_log > 0 ) do_log--;
}

void BriefLog::log(std::string obj, std::string msg){
	#ifdef _DBG_BRIEFLOG
		std::stringstream ss;
		ss.str("");
		ss << "do_log=" << do_log;
		std::cout << s_prtlog( _name, "BriefLog::log()", ss.str()) << std::endl;
	#endif
	if (do_log <= 5 ) {
		std::cout << s_prtlog( _name, obj, msg) << std::endl;
		if (do_log < LONG_MAX ) do_log++;
	}
}

} //namespace
