#include "Drv.h"

namespace Controller_ns {

string                  Drv::raw_io(string quest)    	{ if (_link) return _link->raw_io(quest); else return "?";}

Link_ns::uvalues_t      Drv::update(string channel)  	{
							  Link_ns::uvalues_t uv;
							  if (_link) uv = _link->update(channel);
							  else {
								uv.motor = 55;
							  }
							  return uv;
							}


Link_ns::uvalues_t	Drv::uv() 			{ Link_ns::uvalues_t uv; if (_link) uv = _link->uv(); return uv;}

bool 			Drv::hw_write_enable() 		{ return __hw_write_enable; }

void    		Drv::hw_write_enable(bool b) 	{ __hw_write_enable = b; }

void            	Drv::verbose(int b)        	{
                                                          #ifdef _DBG_VERBOSE
								std::cout << "Drv.verbose()" << std::endl;
							  #endif
							  _verbose = b;
							}

int            		Drv::verbose()         		{ return _verbose;}

void            	Drv::lnk_verbose(int b)   	{
                                                          #ifdef _DBG_VERBOSE
								std::cout << "Drv.lnk_verbose()" << std::endl;
							  #endif
							  if (_link) _link->verbose(b);
							}

int            		Drv::lnk_verbose()         	{ if (_link) return _link->verbose(); else return 0;}

double 			Drv::refresh_etime() 		{ if (_link) return _last_refresh_ms; else return nan("");}

double 			Drv::update_etime() 		{ if (_link) return _link->update_etime(); else return nan("");}

int 			Drv::lnk_flag()      		{ if (_link) return _link->flag(); else return 0;}

bool 			Drv::lnk_flag(int v)		{ if (_link) return _link->flag(v); else return false;}

#if 0
bool 			Drv::lnk_prtLog()      		{ if (_link) return _link->prtLog(); else return false; }
void 			Drv::lnk_prtLog(bool v)		{ if (_link) _link->prtLog(v);}
#else
bool 			Drv::lnk_prtLog()      		{ return _prtLog; }
void 			Drv::lnk_prtLog(bool v)		{ _prtLog = v; if (_link) _link->prtLog(v);}
#endif


double          	Drv::updateDelay() 		{ if (_link) return _link->updateDelay(); else return nan("");}

string			Drv::linkstatus()		{ if (_link) return _link->linkstatus(); else return "NO LINK";}

Link_ns::LinkState_t 	Drv::linkstate()		{ if (_link) return _link->linkstate(); else return Link_ns::LINK_CLOSE;}

bool 			Drv::program_running() 		{ return true; }

string          	Drv::CC_code2str(VNOTU unsigned long CC_code) {return "";}

} /* namespace Controller_ns */
