#ifndef _PRTLOG_H_
#define _PRTLOG_H_

#include <sys/time.h>
#include <string>       // std::string
#include <iostream>     // std::cout
#include <sstream>      // std::stringstream

std::string s_prtlog(std::string _name, std::string obj, std::string s){
  struct timeval tv;

  struct tm * timeinfo;
  char buffer [80];

  char buffer2 [80];

  gettimeofday(&tv, NULL);
  timeinfo = localtime (&tv.tv_sec);

  strftime (buffer,80,"%F %T",timeinfo);
  snprintf(buffer2, 80,".%03d ",(int)((float)tv.tv_usec/1000));

  std::stringstream r;
  r << buffer;
  r << buffer2;
  r << _name << " ";
  if ( obj.size() >= 1 ){
      r << obj;
      r << " ";
  }
  r << s;

  return r.str();
}

void __prtlog(std::string _name, std::string obj, std::string s){
  std::cout << s_prtlog( _name, obj, s) << std::endl;
}

void _errlog(std::string _name, std::string obj, std::string s){
  std::cerr << s_prtlog( _name, obj, s) << std::endl;
}

#endif  /*_PRTLOG_H_ */
