#include "Axis.h"

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>


int main (int argc, char *argv[]){

	char ctrl[] = "pippo";

        Controller_ns::Controller       *controller     = new Controller_ns::Controller(Controller_ns::SIMUL, ctrl, "", false);
        Controller_ns::SimulDrv         *simuld         = (Controller_ns::SimulDrv*)controller->drv();


	for (size_t i = 0; i<5; i++){
		cout << __func__ << " ...:" << i << endl;
		usleep(1000000);
	}

#if 1
	simuld->mpos("", 10);
	
	for (size_t i = 0; i<5; i++){
		cout << __func__ << " ...:" << i << endl;
		usleep(1000000);
	}
#endif
#if 1
	simuld->mpos("", 1000);
	
	for (size_t i = 0; i<2; i++){
		cout << __func__ << " ...:" << i << endl;
		usleep(1000000);
	}

	simuld->stop("");

	for (size_t i = 0; i<2; i++){
		cout << __func__ << " ...:" << i << endl;
		usleep(1000000);
	}
#endif
}
