#ifndef _UTILS_H_
#define _UTILS_H_

inline void prtdbg(std::string s){
  time_t rawtime;
  struct tm * timeinfo;
  char buffer [80];

  time (&rawtime);
  timeinfo = localtime (&rawtime);

  strftime (buffer,80,"%F %T ",timeinfo);

  std::string r(buffer);
  r.append(s);

  std::cout << r << std::endl;
}


#define prtlog(x, y)  _prtlog(device_name, x, y)

inline std::string s_prtlog(std::string _name, std::string obj, std::string s){
  time_t rawtime;
  struct tm * timeinfo;
  char buffer [80];

  time (&rawtime);
  timeinfo = localtime (&rawtime);

  strftime (buffer,80,"%F %T ",timeinfo);

  std::stringstream r;
  r << buffer;
  r << _name << " ";
  if ( obj.size() >= 1 ){
      r << obj;
      r << " ";
  }
  r << s;

  return r.str();
}


inline void _prtlog(std::string _name, std::string obj, std::string s){
  std::cout << s_prtlog( _name, obj, s) << std::endl;
}

#endif  /*_UTILS_H_ */
