#ifndef _BCSTANGOLINK_H_
#define _BCSTANGOLINK_H_

#include "Link.h"
#include "tango.h"

#include <map>

namespace Link_ns {

#define API_CorbaException		"API_CorbaException"
#define API_DeviceTimedOut		"API_DeviceTimedOut"
#define API_CantConnectToDevice		"API_CantConnectToDevice"
#define API_CommandFailed		"API_CommandFailed"


class BcsTangoLink : public Link 
{
private:
	Tango::DeviceProxy *dev;

public:
	BcsTangoLink(string target);
	~BcsTangoLink();

	string raw_io(string quest, bool setstate);

        uvalues_t update(string channel);
	bool  refresh();

	bool ul_write(string channel, string attrname, Tango::DevULong ul);
	bool dbl_write(string channel, string attrname, Tango::DevDouble dbl);

	bool double_cmd(string channel, string cmdname, Tango::DevDouble v);


}; /* class BcsTangoLink */


} /* namespace Link_ns */
#endif /* _BCSTANGOLINK_H_ */
