#ifndef _SIMULLINK_H_
#define _SIMULLINK_H_

#include "Link.h"
#include "SimulThread.h"

#include <map>

namespace Link_ns {

class SimulLink : public Link 
{
private:
	SimulThread_ns::SimulThread *_simulthread;

public:
	SimulLink(string target);
	~SimulLink();

	void set_simulthread(SimulThread_ns::SimulThread * t);
	SimulThread_ns::SimulThread *get_simulthread() { return _simulthread; };

	string raw_io(string quest, bool setstate);

        uvalues_t update(string channel);
	bool  refresh();


}; /* class SimulLink */


} /* namespace Link_ns */
#endif /* _SIMULLINK_H_ */
