#include "Axis.h"

#include <stdlib.h>
#include <string>
#include <algorithm>
#include <iostream>

namespace Axis_ns {

/*typedef enum {
        INIT_ON_DEFPOS = 0,
        INIT_ON_HOME = 1,	//===>>> e' l'"home" attivi per mezza corsa e disattivo per l'altra mezza.... (FEx nativo);
        INIT_ON_RLS = 2,
        INIT_ON_FLS = 4,
        INIT_ON_CUSTOM = 5,
        INIT_ON_RLSIDX = 7,
        INIT_ON_FLSIDX = 8,
        INIT_ON_EDGEPOSDEF = 9,
        INIT_ON_EDGENEGDEF = 10
} AxisInitType_t;
*/

/*====================================================================
*
*	true 		 = init ended      (... switch to FSM_WAIT)
*	false 		 = init in progess (... stay on same _FSM)
*	false/IFSM_ERROR = init error	   (....  ?? FSM_ERROR ?? )
*
*====================================================================*/
bool Axis::mInit(){

	switch(_mInitType){
		case INIT_ON_RLS:
			return rflsInit(LIMIT_RLS);
			break;
		case INIT_ON_FLS:
			return rflsInit(LIMIT_FLS);
			break;
		case INIT_ON_EDGEPOSDEF:
			return homeInit(FIND_HOME_PLUS);
			break;
		case INIT_ON_EDGENEGDEF:
			return homeInit(FIND_HOME_MINUS);
			break;
		case INIT_ON_RLSIDX:
        	case INIT_ON_FLSIDX:
			return indexInit(_mInitType);
			break;
		case INIT_ON_ABSOLUTE:
			return absoluteInit();
			break;
		case INIT_ON_SENCPOS:
			return sencInit(FIND_POS);
			break;
		case INIT_ON_SENCNEG:
			return sencInit(FIND_NEG);
			break;
		case INIT_ON_ROTIDXPOS:
        	case INIT_ON_ROTIDXNEG:
			return rotIdxInit(_mInitType);
			break;
#ifdef _WITH_CIA402_
#if 0
		case CIA402_INIT_ON_RLS:
			return Cia402_rflsInit(LIMIT_RLS);
			break;
		case CIA402_INIT_ON_FLS:
			return Cia402_rflsInit(LIMIT_FLS);
			break;
#endif
		case CIA402_INIT_ON_RLS:
		case CIA402_INIT_ON_FLS:
		case CIA402_INIT_ON_RLSIDX:
		case CIA402_INIT_ON_FLSIDX:
		case CIA402_INIT_ON_ROTIDXPOS:
                case CIA402_INIT_ON_ROTIDXNEG:
			return Cia402Init(_mInitType);
			break;
#endif
		default:
			_mInitFSM = IFSM_ERROR;
			return false;
			break;
	}
	return false;
}

} /* namespace Axis_ns */
